include:
  - project: rwickit/cicd/cfn
    ref: v1 ## The branch, tag, or SHA to use  (default: main)
    file: deploy.yml ## The path to the file to include (default: .gitlab-ci.yml)

variables:
  ## PROJECT VARIABLES
  SOURCE_DIR: ${CI_PROJECT_DIR}/cloudformation/
  ROLE_SESSION_NAME: ${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}

  ## DELIVER VARIABLES
  BUCKET: << YOUR BUCKET NAME >>
  BUCKET_REGION: us-west-2
  DELIVERY_PATH: ${BUCKET}/${CI_PROJECT_NAME}

  ## DEPLOY VARIABLES
  CLI_REGION: us-west-2
  STACK_NAME: << YOUR STACK NAME >>
  TEMPLATE: << TEMPLATE FILE NAME>>.yml
  DEPLOY_PATH: ${CI_PROJECT_NAME}/${TEMPLATE}

## JOBS:

deliver:template:
  stage: deliver
  extends: .deliver
  variables:
    PARAMS: << PARAM FILE NAME >>
    ROLE_ARN: arn:aws:iam::${ACCOUNT ID}:role/${ROLE NAME}

stage:dev:
  stage: stage
  extends: .stage
  needs: ["deliver:template"]
  variables:
    PARAMS: << PARAM FILE NAME >>
    ROLE_ARN: arn:aws:iam::${ACCOUNT ID}:role/${ROLE NAME}

stage:prod:
  stage: stage
  extends: .stage
  needs: ["deliver:template"]
  variables:
    PARAMS: << PARAM FILE NAME >>
    ROLE_ARN: arn:aws:iam::${ACCOUNT ID}:role/${ROLE NAME}

deploy:dev:
  stage: deploy
  extends: .deploy
  needs: ["stage:delivery"]
  variables:
    PARAMS: << PARAM FILE NAME >>
    ROLE_ARN: arn:aws:iam::${ACCOUNT ID}:role/${ROLE NAME}

deploy:prod:
  stage: deploy
  extends: .deploy
  needs: ["stage:streaming"]
  variables:
    PARAMS: << PARAM FILE NAME >>
    ROLE_ARN: arn:aws:iam::${ACCOUNT ID}:role/${ROLE NAME}
